<?php
#!/usr/local/bin/php

if (defined('STDIN')) {
  $window_length = $argv[1];
  $name = $argv[2];
}

$minimum_motif_length = 1;		$maximum_motif_length = $window_length;	

$file_lines = file("./out.txt");		$out = "./out2.txt";
foreach ($file_lines as $seq) {	#Go over file; one sequence per line
	$llll = strlen($seq)-1;		$result = analyse_seq ($seq, $window_length, $minimum_motif_length, $maximum_motif_length);
	for($i = 0; $i < strlen($seq); $i++) {
		if (isset($result[$i][6])) {
				$seq1 = $result[$i][6];		$occ = array();					// Obtain prevalence of most occurring aa
				$occ[0] = substr_count("$seq1", "A");$occ[1] = substr_count("$seq1", "C");$occ[2] = substr_count("$seq1", "D");$occ[3] = substr_count("$seq1", "E");
				$occ[4] = substr_count("$seq1", "F");$occ[5] = substr_count("$seq1", "G");$occ[6] = substr_count("$seq1", "H");$occ[7] = substr_count("$seq1", "I");
				$occ[8] = substr_count("$seq1", "K");$occ[9] = substr_count("$seq1", "L");$occ[10] = substr_count("$seq1", "M");$occ[11] = substr_count("$seq1", "N");
				$occ[12] = substr_count("$seq1", "P");$occ[13] = substr_count("$seq1", "Q");$occ[14] = substr_count("$seq1", "R");$occ[15] = substr_count("$seq1", "S");
				$occ[16] = substr_count("$seq1", "T");$occ[17] = substr_count("$seq1", "V");$occ[18] = substr_count("$seq1", "W");$occ[19] = substr_count("$seq1", "Y");
				rsort($occ);	$perc_most = ($occ[0]/$window_length);			// Higher prevalence is $occ[0]
				$rtv = substr_count("$seq1", "X");		$perc_rtv = ($rtv/$window_length);
				if($perc_rtv >= $perc_most)continue;		//Only continue if "X" is not the most prevalent residue
				file_put_contents($out, $result[$i][4], FILE_APPEND);	$text = "\t"; file_put_contents($out, $text, FILE_APPEND);
				file_put_contents($out, $perc_most, FILE_APPEND);	$text = "\n"; file_put_contents($out, $text, FILE_APPEND);
}	}	}
////////////////////////////////////////////////////////


//FUNCTION1
function minimal_mutations($seq, $window_start, $window_length, $pattern_length, &$pattern) {
	$pattern = "";
	for ($i = 0; $i < 26; $i++) {	for ($j = 0; $j < $pattern_length; $j++) {  $my_index[$i][$j] = 0; }   }
	for ($j = 0; $j < $pattern_length; $j++) {  $max_cols[$j] = 0;        $max_ids[$j] = -1;   }
	for ($i = $window_start; $i < min ($window_start + $window_length, strlen($seq)); $i++) {
		$row = ord($seq[$i]) - ord('A');  $col = ($i - $window_start) % $pattern_length;  
		$my_index[$row][$col]++;
	}
	$sum = 0;
	for ($j = 0; $j < $pattern_length; $j++) {
		$max_cols[$j] = $my_index[0][$j];    $max_ids[$j] = 0;
		for ($i = 1; $i < 26; $i++) {	if ($max_cols[$j] < $my_index[$i][$j]) {	$max_cols[$j] = $my_index[$i][$j];   $max_ids[$j] = $i; }		}
		$sum += $max_cols[$j];
	}
	for ($j = 0; $j < $pattern_length; $j++) {  $pattern = $pattern . chr($max_ids[$j] + ord('A'));   }
	return $window_length - $sum;
}
//FUNCTION2
function analyse_seq($seq, $window_length, $min_pattern_length, $max_pattern_length) {
	$min_mutations = 0;    $max_window_start = strlen($seq);    $result_number = 0;
	for ($window_start = 0; $window_start < $max_window_start-$window_length; $window_start++) {
		$pattern_length = max($min_pattern_length, 1);
		$min_mutations = minimal_mutations($seq, $window_start, $window_length, $pattern_length, $pattern);
		$pattern_length++;		$min_pattern = $pattern;
		for ($pattern_length; $pattern_length <= min($max_pattern_length, $window_length / 2); $pattern_length++) {
			if (1 || ($window_length % $pattern_length) == 0) {
				$min = minimal_mutations($seq, $window_start, $window_length, $pattern_length, $pattern);
				if ($min < $min_mutations) {	$min_mutations = $min;  $min_pattern = $pattern;	} 
				else if (($min == $min_mutations) && (strlen($pattern) < strlen($min_pattern))) {
					$min_mutations = $min;  $min_pattern = $pattern;
		}	}	}
		$result[$result_number][0] = "-";											$result[$result_number][1] = $window_start;		$result[$result_number][2] = $window_length;	
		$result[$result_number][3] = strlen($min_pattern);		$result[$result_number][4] = $min_mutations;	$result[$result_number][5] = $min_pattern;
		$result[$result_number][6] = "";
		for ($i = $window_start; $i < $window_start + $window_length; $i++) {	$result[$result_number][6].=$seq[$i];	}
		$result_number++;  
	}	return $result;
}
?>
