#!/usr/bin/perl
use strict;
use Bio::SeqIO;
my ($file) = @ARGV;
my $random_dir = "."; 
my $window = 20;
###################GO OVER MULTIFASTA TO GET THE PROTEIN SEQUENCES ONCE AT A TIME
my $output = "$random_dir/$file-win_per_coord.txt"; open (OOP,">>$output");	print OOP "x\ty\n";
open(IN,"<$file");	my $multifasta = Bio::SeqIO->new( -file  => "<$file" , '-format' => 'fasta'); 
my $index = 0;
while (my $seq = $multifasta->next_seq()) {  	
	my $ac0 = $seq->display_id; my @ac02 = split(/\|/,$ac0);	my $ac = $ac02[1]; my $ss = $seq->seq;		my $lle = length($ss);
	$index++; print "$index\n";
	next if (length($ss) < 20);		#As WL = 20, do not process sequence shorter than 20 amino acids
###################DIVIDE PROTEIN IN FILE IN WINDOWS
	my $out = "out.txt";	open (OUT, ">>$out");
	for (my $tr = 0; $tr < $lle; $tr++) {	my $ref = substr($ss,$tr,$window);my $chek = length($ref);next if ($chek < $window);print OUT "$ref\n";}	
	close OUT;
###################ANALYZE CURRENT PROTEIN
	`php RES_multiplexed.php $window $file`;	unlink $out;	
###################ANALYZE RESULTS FOR CURRENT PROTEIN
	`cat out2.txt >> $output`;
	unlink "$random_dir/out2.txt";	
}	close OOP;
###################GENERATE PLOT
open (AUX,">>aux.R");	print AUX "
library(ggplot2);library(gridExtra);
df = read.table(\"$output\",sep='\t', header=T, dec=\".\")
dat <- data.frame(x=df\$x, y=df\$y)
a=df\$x;b=df\$y;AA=xyTable(a,b);BB<-data.frame(AA);c=(AA\$number/nrow(dat))*100;d=format(round(c, 2), nsmall = 2)
my_breaks = c(0.001, 0.01, 1, 10)
c <- round(c, digits = 3)
p1 <- ggplot(BB, aes(BB\$x, BB\$y)) + geom_tile(aes(fill = c)) + 
	labs(x = \"MMPR\",y = \"% of most frequent amino acid\",colour = \"%\") +
  scale_y_continuous(breaks=c(0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1),limits=c(0, 1.1)) + 
	scale_x_continuous(breaks=c(0,1,2,3,4,5,6,7,8,9,10),limits=c(-0.5, 10.5)) +
  theme(axis.line = element_line(size = 0.5, linetype = \"solid\"),legend.position=c(0.9,0.85)) + 
	scale_fill_gradient(name = \"% (log10)\", trans = \"log2\", breaks = my_breaks, labels = my_breaks)+
	geom_segment(aes(x = 8.5, y = 0.075, xend = 8.5, yend = 0.275), color=\"red\") +
	geom_segment(aes(x = 8.5, y = 0.275, xend = 10.5, yend = 0.275), color=\"red\") +
	geom_segment(aes(x = 7.5, y = 0.075, xend = 7.5, yend = 0.325), color=\"green\") +
	geom_segment(aes(x = 7.5, y = 0.325, xend = 10.5, yend = 0.325), color=\"green\") +
	geom_segment(aes(x = 6.5, y = 0.075, xend = 6.5, yend = 0.375), color=\"orange\") +
	geom_segment(aes(x = 6.5, y = 0.375, xend = 10.5, yend = 0.375), color=\"orange\")
pdf('$file.pdf');
grid.arrange(p1)
dev.off()
";
##
`Rscript aux.R`; unlink $output; unlink "aux.R";
exit;
